create database if not exists multi_catalog;
use multi_catalog;

CREATE TABLE `test_compress_partitioned`(
  `watchid` string,
  `javaenable` smallint,
  `title` string,
  `goodevent` smallint,
  `eventtime` timestamp,
  `eventdate` date,
  `counterid` bigint,
  `clientip` bigint,
  `clientip6` char(50),
  `regionid` bigint,
  `userid` string,
  `counterclass` tinyint,
  `os` smallint,
  `useragent` smallint,
  `url` string,
  `referer` string,
  `urldomain` string,
  `refererdomain` string,
  `refresh` smallint,
  `isrobot` smallint,
  `referercategories` string,
  `urlcategories` string,
  `urlregions` string,
  `refererregions` string,
  `resolutionwidth` int,
  `resolutionheight` int,
  `resolutiondepth` smallint,
  `flashmajor` smallint,
  `flashminor` smallint,
  `flashminor2` string,
  `netmajor` smallint,
  `netminor` smallint,
  `useragentmajor` int,
  `useragentminor` char(4),
  `cookieenable` smallint,
  `javascriptenable` smallint,
  `ismobile` smallint,
  `mobilephone` smallint,
  `mobilephonemodel` string,
  `params` string,
  `ipnetworkid` bigint,
  `traficsourceid` tinyint,
  `searchengineid` int,
  `searchphrase` string,
  `advengineid` smallint,
  `isartifical` smallint,
  `windowclientwidth` int,
  `windowclientheight` int,
  `clienttimezone` smallint,
  `clienteventtime` timestamp,
  `silverlightversion1` smallint,
  `silverlightversion2` smallint,
  `silverlightversion3` bigint,
  `silverlightversion4` int,
  `pagecharset` string,
  `codeversion` bigint,
  `islink` smallint,
  `isdownload` smallint,
  `isnotbounce` smallint,
  `funiqid` string,
  `hid` bigint,
  `isoldcounter` smallint,
  `isevent` smallint,
  `isparameter` smallint,
  `dontcounthits` smallint,
  `withhash` smallint,
  `hitcolor` char(2),
  `utceventtime` timestamp,
  `age` smallint,
  `sex` smallint,
  `income` smallint,
  `interests` int,
  `robotness` smallint,
  `generalinterests` string,
  `remoteip` bigint,
  `remoteip6` char(50),
  `windowname` int,
  `openername` int,
  `historylength` smallint,
  `browserlanguage` char(4),
  `browsercountry` char(4),
  `socialnetwork` string,
  `socialaction` string,
  `httperror` int,
  `sendtiming` int,
  `dnstiming` int,
  `connecttiming` int,
  `responsestarttiming` int,
  `responseendtiming` int,
  `fetchtiming` int,
  `redirecttiming` int,
  `dominteractivetiming` int,
  `domcontentloadedtiming` int,
  `domcompletetiming` int,
  `loadeventstarttiming` int,
  `loadeventendtiming` int,
  `nstodomcontentloadedtiming` int,
  `firstpainttiming` int,
  `redirectcount` tinyint,
  `socialsourcenetworkid` smallint,
  `socialsourcepage` string,
  `paramprice` bigint,
  `paramorderid` string,
  `paramcurrency` char(6),
  `paramcurrencyid` int,
  `goalsreached` string,
  `openstatservicename` string,
  `openstatcampaignid` string,
  `openstatadid` string,
  `openstatsourceid` string,
  `utmsource` string,
  `utmmedium` string,
  `utmcampaign` string,
  `utmcontent` string,
  `utmterm` string,
  `fromtag` string,
  `hasgclid` smallint,
  `refererhash` string,
  `urlhash` string,
  `clid` bigint,
  `yclid` string,
  `shareservice` string,
  `shareurl` string,
  `sharetitle` string,
  `parsedparamskey1` string,
  `parsedparamskey2` string,
  `parsedparamskey3` string,
  `parsedparamskey4` string,
  `parsedparamskey5` string,
  `parsedparamsvaluedouble` double,
  `islandid` char(40),
  `requestnum` bigint,
  `requesttry` smallint)
PARTITIONED BY (
  `dt` string)
ROW FORMAT SERDE
  'org.apache.hadoop.hive.serde2.lazy.LazySimpleSerDe'
STORED AS INPUTFORMAT
  'org.apache.hadoop.mapred.TextInputFormat'
OUTPUTFORMAT
  'org.apache.hadoop.hive.ql.io.HiveIgnoreKeyTextOutputFormat'
LOCATION
  '/user/doris/suites/multi_catalog/test_compress_partitioned'
TBLPROPERTIES (
  'transient_lastDdlTime'='1692589095');

msck repair table test_compress_partitioned;

